from html import unescape


class AttributesParser:

    def __init__(self) -> None:
        pass

    def parse(self, attributes: str) -> dict:
        # Get rid of the leading 'E:' and unescape the rest.
        attributes = unescape(attributes[2:])

        return dict((kv.split('=') for kv in attributes.split('&')))

class ProductsParser:

    def __init__(self) -> None:
        pass

    def parse(self, products: str) -> list:
        # Get rid of the leading 'E:' and unescape the rest.
        products = unescape(products[2:])

        return [dict((kv.split('=') for kv in product.split('&'))) for product in products.split(';')]
